[PATCH] D34924: [Bash-autocompletion] Add support for older bash version.
Yuka Takahashi via Phabricator via cfe-commits
cfe-commits at lists.llvm.org
Sat Jul 1 11:33:16 PDT 2017
This revision was automatically updated to reflect the committed changes.
Closed by commit rL306962: [Bash-autocompletion] Add support for older bash version. (authored by yamaguchi).
Changed prior to commit:
https://reviews.llvm.org/D34924?vs=104996&id=104999#toc
Repository:
rL LLVM
https://reviews.llvm.org/D34924
Files:
cfe/trunk/utils/bash-autocomplete.sh
Index: cfe/trunk/utils/bash-autocomplete.sh
===================================================================
--- cfe/trunk/utils/bash-autocomplete.sh
+++ cfe/trunk/utils/bash-autocomplete.sh
@@ -1,15 +1,33 @@
# Please add "source /path/to/bash-autocomplete.sh" to your .bashrc to use this.
+
+_clang_filedir()
+{
+ # _filedir function provided by recent versions of bash-completion package is
+ # better than "compgen -f" because the former honors spaces in pathnames while
+ # the latter doesn't. So we use compgen only when _filedir is not provided.
+ _filedir 2> /dev/null || COMPREPLY=( $( compgen -f ) )
+}
+
_clang()
{
- local cur prev words cword arg flags
- _init_completion -n : || return
+ local cur prev words cword arg flags w1 w2
+ # If latest bash-completion is not supported just initialize COMPREPLY and
+ # initialize variables by setting manualy.
+ _init_completion -n 2> /dev/null
+ if [[ "$?" != 0 ]]; then
+ COMPREPLY=()
+ cword=$COMP_CWORD
+ cur="${COMP_WORDS[$cword]}"
+ fi
# bash always separates '=' as a token even if there's no space before/after '='.
# On the other hand, '=' is just a regular character for clang options that
# contain '='. For example, "-stdlib=" is defined as is, instead of "-stdlib" and "=".
# So, we need to partially undo bash tokenization here for integrity.
- local w1="${COMP_WORDS[$cword - 1]}"
- local w2="${COMP_WORDS[$cword - 2]}"
+ w1="${COMP_WORDS[$cword - 1]}"
+ if [[ $cword > 1 ]]; then
+ w2="${COMP_WORDS[$cword - 2]}"
+ fi
if [[ "$cur" == -* ]]; then
# -foo<tab>
arg="$cur"
@@ -30,18 +48,18 @@
# If clang is old that it does not support --autocomplete,
# fall back to the filename completion.
if [[ "$?" != 0 ]]; then
- _filedir
+ _clang_filedir
return
fi
if [[ "$cur" == '=' ]]; then
COMPREPLY=( $( compgen -W "$flags" -- "") )
elif [[ "$flags" == "" || "$arg" == "" ]]; then
- _filedir
+ _clang_filedir
else
# Bash automatically appends a space after '=' by default.
# Disable it so that it works nicely for options in the form of -foo=bar.
- [[ "${flags: -1}" == '=' ]] && compopt -o nospace
+ [[ "${flags: -1}" == '=' ]] && compopt -o nospace 2> /dev/null
COMPREPLY=( $( compgen -W "$flags" -- "$cur" ) )
fi
}
-------------- next part --------------
A non-text attachment was scrubbed...
Name: D34924.104999.patch
Type: text/x-patch
Size: 2312 bytes
Desc: not available
URL: <http://lists.llvm.org/pipermail/cfe-commits/attachments/20170701/468a392d/attachment.bin>
More information about the cfe-commits
mailing list